> ## Documentation Index
> Fetch the complete documentation index at: https://docs.whirl.sh/llms.txt
> Use this file to discover all available pages before exploring further.

# List event types

> The events you can subscribe to, and what they contain.



## OpenAPI

````yaml GET /events
openapi: 3.1.0
info:
  title: Whirl API
  version: 1.0.0
  description: >-
    Read and change Whirl workspaces, tasks, reminders, agents' instructions and
    approvals as the signed-in user. The same operations are available as tools
    on the MCP server at /mcp.
servers:
  - url: https://api.whirl.sh/api/v1
security:
  - oauth2: []
paths:
  /events:
    get:
      tags:
        - workspace
      summary: List event types
      description: >-
        Discover events and their filter and payload schemas for webhook
        subscriptions.
      operationId: list_event_types
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  events:
                    type: array
                    items:
                      type: object
                      properties:
                        name:
                          type: string
                          enum:
                            - approval.required
                            - agent_run.finished
                            - task.assigned
                            - task.created
                            - task.status_changed
                            - agent_run.started
                            - task.mentioned
                        description:
                          type: string
                        delivery:
                          type: array
                          items:
                            type: string
                        inputSchema:
                          $ref: >-
                            #/components/schemas/list_event_types_response___schema0
                        payloadSchema:
                          $ref: >-
                            #/components/schemas/list_event_types_response___schema1
                      required:
                        - name
                        - description
                        - delivery
                        - inputSchema
                        - payloadSchema
                      additionalProperties: false
                required:
                  - events
                additionalProperties: false
        '400':
          $ref: '#/components/responses/Problem'
        '401':
          $ref: '#/components/responses/Problem'
        '403':
          $ref: '#/components/responses/Problem'
        '404':
          $ref: '#/components/responses/Problem'
        '409':
          $ref: '#/components/responses/Problem'
        '422':
          $ref: '#/components/responses/Problem'
        '429':
          $ref: '#/components/responses/Problem'
      security:
        - oauth2:
            - workspace:read
components:
  schemas:
    list_event_types_response___schema0:
      anyOf:
        - type: string
        - type: number
        - type: boolean
        - type: 'null'
        - type: array
          items:
            $ref: '#/components/schemas/list_event_types_response___schema0'
        - type: object
          propertyNames:
            type: string
          additionalProperties:
            $ref: '#/components/schemas/list_event_types_response___schema0'
    list_event_types_response___schema1:
      anyOf:
        - type: string
        - type: number
        - type: boolean
        - type: 'null'
        - type: array
          items:
            $ref: '#/components/schemas/list_event_types_response___schema1'
        - type: object
          propertyNames:
            type: string
          additionalProperties:
            $ref: '#/components/schemas/list_event_types_response___schema1'
    Problem:
      type: object
      properties:
        type:
          type: string
        title:
          type: string
        status:
          type: integer
        detail:
          type: string
        code:
          type: string
      required:
        - title
        - status
        - code
  responses:
    Problem:
      description: RFC 9457 problem details
      content:
        application/problem+json:
          schema:
            $ref: '#/components/schemas/Problem'
  securitySchemes:
    oauth2:
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://api.whirl.sh/oauth/authorize
          tokenUrl: https://api.whirl.sh/oauth/token
          refreshUrl: https://api.whirl.sh/oauth/token
          scopes:
            workspace:read: >-
              Workspaces, tasks, People, task context, notes, messages,
              reminders, and pending approvals.
            workspace:write: >-
              Create and update tasks, People, task context, notes, tags,
              reminders, and workspaces.
            agents:read: >-
              Agents, runs, configuration, handbook, memory, tone examples,
              scheduled tasks, and connected-service research.
            agents:write: >-
              Edit agent configuration, handbook, memory, tone examples, and
              schedules, and give agents tasks.
            approvals:write: Approve, reject, or edit actions agents want to take.
            offline_access: >-
              Keep access without asking you to sign in again, until you
              disconnect it.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.